﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Interop;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace IPC.AppB
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private MainWindow _instance;
        private object _lock = new object();
        private string msgtext = "inter-process communtcation";
        private uint msg;
        [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
        static extern uint RegisterWindowMessage(string lpString);

        public MainWindow()
        {
            InitializeComponent();

            this.Loaded += (s, e) => {
                Load();
            };

            //this.btnOK.Click += (s, e) => {
            //    MessageBox.Show("AppB's button is clicked.");
            //};
        }

        public MainWindow Instance
        {
            get
            {
                lock (_lock)
                {
                    if (_instance == null)
                    {
                        _instance = new MainWindow();
                    }
                    return _instance;
                }
            }
        }

        protected void Load()
        {
            MainWindow main = Instance;
            main.Dispatcher.Invoke(delegate {
                msg = RegisterWindowMessage(msgtext);
                if (msg == 0)
                {
                    MessageBox.Show(Marshal.GetLastWin32Error().ToString());
                }
            });
        }

        int i = 0;
        protected void PromptMsgs()
        {
            this.Dispatcher.Invoke(new Action(delegate
            {
                btnOK.Click += (s, e) =>
                {
                    //do nothing..
                };

                this.btnOK.Content = (++i).ToString();

                MessageBox.Show("AppB's button is clicked.");
            }));
        }

        protected override void OnSourceInitialized(EventArgs e)
        {
            base.OnSourceInitialized(e);

            HwndSource sorce = PresentationSource.FromVisual(this) as HwndSource;
            sorce.AddHook(new HwndSourceHook(WndProc));
        }

        private IntPtr WndProc(IntPtr hwnd, int msg, IntPtr wParam, IntPtr lParam, ref bool handled)
        {
            if (msg == this.msg)
            {
                PromptMsgs();
            }
            return IntPtr.Zero;
        }

        protected override void OnClosing(System.ComponentModel.CancelEventArgs e)
        {
            base.OnClosing(e);

            if (this.Dispatcher.Thread != null)
            {
                Environment.Exit(0);
            }
        }
    }
}
